SystemOrganization addCategory: #'Macro-Tests'!

!Object class methodsFor: '*Macro' stamp: 'fbs 5/24/2012 10:58'!
addMethod: aSelector doing: aBlock
	| args ast source |
	ast := aBlock decompile.
	args := ast arguments collect: [:arg | arg key].
	source := ast statements printString.
	source := (self methodHead: aSelector withArgs: args) , Character cr , (source copyFrom: 3 to: (source size - 2)).
	^ self compile: source
	classified: 'random'
	notifying: nil! !

!Object class methodsFor: '*Macro' stamp: 'fbs 5/23/2012 17:09'!
methodHead: aSelector withArgs: someStrings
	| chunks |
	(aSelector numArgs = 0) ifTrue: [^ aSelector asString].
	chunks := (aSelector splitBy: ':') allButLast. "last is the empty string because the selector ends with ':'."
	^ (chunks with: someStrings collect: [:keyword :arg | (keyword , ':') asSymbol , ' ' , arg])
		inject: ''
		into: #,.! !

TestCase subclass: #MethodGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Macro-Tests'!

!MethodGeneratorTest methodsFor: 'running' stamp: 'fbs 5/23/2012 17:05'!
setUp
	Object subclass: #MacroTestsUsesThisClassToTestThingsAndItIsEphemeral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Macro-Tests'! !

!MethodGeneratorTest methodsFor: 'running' stamp: 'fbs 5/23/2012 17:08'!
tearDown
	self victimClass removeFromSystem.! !

!MethodGeneratorTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/23/2012 17:07'!
testShouldGenerateNullaryMethod
	self victimClass addMethod: #foo doing: [^ 1].
	self assert: 1 equals: self victimClass new foo.! !

!MethodGeneratorTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/23/2012 17:08'!
victimClass
	^ self class environment at: #MacroTestsUsesThisClassToTestThingsAndItIsEphemeral! !
